# coding: utf-8

"""
Mozart platform API

API for interacting with the Mozart platform.

The version of the OpenAPI document: 0.2.0
Contact: support@bang-olufsen.dk
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

try:
    from pydantic.v1 import BaseModel, StrictStr
except ImportError:
    from pydantic import BaseModel, StrictStr


class ActionSoundProfile(BaseModel):
    """
    ActionSoundProfile
    """

    directivity: Optional[StrictStr] = None
    __properties = ["directivity"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ActionSoundProfile:
        """Create an instance of ActionSoundProfile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # set to None if directivity (nullable) is None
        # and __fields_set__ contains the field
        if self.directivity is None and "directivity" in self.__fields_set__:
            _dict["directivity"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ActionSoundProfile:
        """Create an instance of ActionSoundProfile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ActionSoundProfile.parse_obj(obj)

        _obj = ActionSoundProfile.parse_obj({"directivity": obj.get("directivity")})
        return _obj
